﻿///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'toObject' add to Xml class.   (Alternative method of xml.readtables (more compact xml file)
///////////////////////////////////////////////////////////////////////////////////////////
//   tables mySql in Xml object ==> a structured Array
//   Xml structure : 
//		Only one markup with de basename : ex <MyBase>
//			One markup for each table ex : <custumer>, <item>
//				One markup named 'DATADESC'.
//              	 One markup for each column 's name (without content) : ex <name/> <adress/> <zipcode/> ...
//              One markup named 'DATAS'.
//					 A list of markup named 'C' with the content of all columns of all line 
//					  ex: <C>Content of the field(column) n° n of the record(line) n° m</C>
//
//		This method may be used with any type of arbo :
//			ex : <infos> -> <databasename> -> <contentname> -> content    instead of
//				 <base>  -> <tablename>    ->  <fieldname>  -> data
//////////////////////////////////////////////////////////////////////////////////////
// methods :
//				<Object> = object_xml.toObject() ;
//
//		        			Return an Object with the tables's fields et contents
//						    Object.table_name[line_number].column_name ;
//
//
// Example : 		
//				mySend = new loadVars() ;
//				myReceive = new Xml () ;
//				myReceive.onLoad = function () {
//						myText.text = this.toObject().customers[3].name ;
//		    			// Display the name of the third customer
//				}
//   			mySend.request = "SELECT * from customers" ; 					
//				mySend.sendAndload("php/readMySql.php",myReceive);
// 				// You have to create the "php/readMySql.php" program.									
/////////////////////////////////////////////////////////////////////////////
//
// 
XML.prototype.ignoreWhite = true;
XML.prototype.toObject = function() {
	// init array "twsap" used to replace coded strings (because xml invalides characters)
	var tswap = new Array();
	var o = new Object();
	o.src = "{";
	o.dest = "<";
	tswap.push(o);
	var o = new Object();
	o.src = "}";
	o.dest = ">";
	tswap.push(o);
	var o = new Object();
	o.src = "e";
	o.dest = "&";
	tswap.push(o);
	// create object with all tables
	var t = this.lastChild.childNodes;
	var returnedObject = new Object();
	for (var n in t) {
		// for each table in first xml node
		if (t[n].nodeName != undefined) {
			var nf = t[n].nodeName;
			returnedObject[t[n].nodeName] = new Array();
			var nline = 0;
			// Init sgbd line counter 
			var t2 = t[n].childNodes;
			// Recup content of one table
			for (var n2=0; n2<t2.length; n2++) {
				// for each node 
				if (t2[n2].nodeName == "DATADESC") {
					// columns names markup 
					var t3 = t2[n2].childNodes;
					// recup all columns 
					var tcolumn = new Array();
					// create object for all columns names
					var ncol = 0;
					// Init nb column  counter 
					for (var n3=0; n3<t3.length; n3++) {
						// for each columns name in xml							
						if (t3[n3].nodeName != undefined) {
							// loop garbage
							var str = new String(t3[n3].nodeName);
							str.str_replace(tswap, "~#");
							tcolumn[ncol] = str;
							ncol++;
						}
						// end : if (t3[n3].nodeName != undefined) { // loop garbage
					}
					// end : for (n3 in t3) {   // for each columns name in xml
					var maxcol = ncol-1;
				}
				// end : if (t2[n2].nodeName == "DATADESC") {	// columns names markup 
				if (t2[n2].nodeName == "DATAS") {
					// all datas container markup 
					var t3 = t2[n2].childNodes;
					// recup all datas of all line 
					var current_col = 0;
					// current column number 
					var oline = new Object();
					// Current line
					for (var n3=0; n3<t3.length; n3++) {
						// for each datas node
						if (t3[n3].nodeName != undefined) {
							// // loop garbage
							if (current_col>maxcol) {
								nline++;
								returnedObject[nf][nline] = oline;
								// add object for one line in tables Array
								current_col = 0;
								// current column number 
								oline = new Object();
								// Current line
							}
							var str = new String(t3[n3].firstChild.nodeValue);
							// One data
							oline[tcolumn[current_col]] = str.str_replace(tswap, "~#");
							// add datas in oject for line
							current_col++;
						}
						// end : if (t3[n3].nodeName != undefined) { // // loop garbage
					}
					// end : for (n3 in t3) {   // for each datas node
					nline++;
					returnedObject[nf][nline] = oline;						
					// add object for one line in tables Array
				}
				// end : if (t2[n2].nodeName == "DATAS) {	// all datas container markup
			}
			// end : for (n2 in t2) { 	// for each node 
		}
		// end : if (t[n].nodeName != undefined) {
	}
	// end : for (n in t) { // for each table in first xml node
	
	return returnedObject;
	// Return the object with all tableName[lines].columName
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode xml.toObject //////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'readbases' add to Xml class.   (read xml arbo which is a sgbdr structure
///////////////////////////////////////////////////////////////////////////////////////////
//   bases and tables mySql in Xml object ==> an arbo structured Array
//   Xml structure : 
//		Only one markup : <SERVER> ... </SERVER>
//			One markup for each base 
//				One markup for each table
//              	 One markup for each field
//				One markup : <_TABLE.STATUS> ... </_TABLE.STATUS> 
//					One markup for each base 
//						One <DATADESC> and <DATAS> markup for the bases's "table status" 
//							(see "toObject()" method for detail).
//				One markup : <_TABLE.INDEXS> ... </_TABLE.INDEXS> 
//					One markup for each table 
//						One <DATADESC> and <DATAS> markup for the table's indexs description
//							(see "toObject()" method for detail).
//              
//
//////////////////////////////////////////////////////////////////////////////////////
// methods :
//				<Object> = object_xml.readbases() ;
//
//		        			Return an Onject from a structured SGBDR (in XML format)
//						    Array[x].name 						<- "basename" 
//								    .table[y].name 				<- "tablename" 
//									         . field[z].name 	<- "fieldName"
//
//
// Example : 		
//				mySend = new loadVars() ;
//				myReceive = new Xml () ;
//				myReceive.onLoad = function () {
//						myText.text = this.readBases[3].table[5].field[12].name ;
//		    			// Display the name of the #12 field of the #5 table of the #3 base 
//				}
//   						
//				mySend.load("php/mySql.xml");
// 				// You have to create the file "php/mySql.xml" 									
/////////////////////////////////////////////////////////////////////////////
//
// 
XML.prototype.ignoreWhite = true;
XML.prototype.readBases = function() {
	// create object with all tables
	var t = this.lastChild.childNodes;
	//init main Array
	tFiles = new Array();
	var o = new Object();
	tfiles.push(o);
	for (n=0; n<t.length; n++) {
		// for each base in first xml node <SERVER>
		if (t[n].nodeName != undefined) {
			// loop garbage
			var o = new Object();
			o.name = t[n].nodeName;			
			o.table = new Array();
			var oo = new Object();
			o.table.push(oo);
			o.tableStatus = new Object() ;
			o.tableIndexs = new Object() ;
			tfiles.push(o);
			
			var t2 = t[n].childNodes;
			// Recup content of one base
			for (n2=0; n2<t2.length; n2++) {
			// for each table
				//     (loop garbage)
				if (t2[n2].nodeName != undefined) {
					if ( t2[n2].nodeName == "_TABLE.STATUS") {	
						var xXml = new XML( t2[n2].toString() ) ;
						tfiles[n+1].tableStatus = xXml.toObject();	
					} else if (t2[n2].nodeName == "_TABLE.INDEXS") {
						var xXml = new XML( t2[n2].toString() ) ;
						tfiles[n+1].tableIndexs = xXml.toObject();	
					} else {
						var o = new Object();
						o.name = t2[n2].nodeName;						
						o.field = new Array();
						var oo = new Object();
						o.field.push(oo);
						tfiles[n+1].table.push(o);
						var t3 = t2[n2].childNodes;
						// Recup content of one table
						for (n3=0; n3<t3.length; n3++) {
							// for each field
							if (t3[n3].nodeName != undefined) {
								// loop garbage
								var o = new Object();
								o.name = t3[n3].nodeName;
								tfiles[n+1].table[n2+1].field.push(o);
							}
							// end : if (t3[n3].nodeName != undefined) { // loop garbage
						}
						// end : for (n3=0;n3<t3.length;n3++) {   // for each field						
						delete tfiles[n+1].table[n2+1].field[0];
					} // End : if ( t2[n2].nodeName == "_TABLE.STATUS") {
				}
				// end : if (t2[n2].nodeName != undefined) { // loop garbage					
			}
			// end : for (n2=0 ;n2<t2.length;n2++ ) {	// for each table
			delete tfiles[n+1].table[0];			
		}
		// end : if (t[n].nodeName != undefined) { // loop garbage
	}
	// end : for (n=0;n<t.length;n++) { // for each base in first xml node <SERVER>
	delete o;
	delete tfiles[0];
	delete oo;
	
	return tfiles;
	
	// Return the onject with all tables[lines].colmums
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode xml.readbases //////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'isSetAndNotNull' add to String class
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.isSetAndNotNull = function() {
	
	var x = this;
	if (x instanceof Number) {
		x = x.toString();
		if (x == "0") {
			return undefined;
		}
		if (x == "NaN") {
			return undefined;
		}
	} else if (x instanceof String) {
		if (x.length == undefined) {
			return undefined;
		}
		if (x.length<1) {
			return undefined;
		}
	} else {		
		var j = 0;
		for (var i in x) {
			j++;
		}		
		if (j<2 && !(x.valueOf().length)) {
			return undefined;
		}
	}
	// Instance of Object only in the future !!!
	return true;
};
Number.prototype.isSetAndNotNull = String.prototype.isSetAndNotNull ;
Array.prototype.isSetAndNotNull = String.prototype.isSetAndNotNull ;
ASSetPropFlags(Array.prototype, "isSetAndNotNull",1);
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END : Méthod 'isSetAndNotNull' add to String and Number class //////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'str_replace' add to the class : String of Flash
///////////////////////////////////////////////////////////////////////////////////////////
// 
// What do it :
// 	Change all occurence of <sources> by <destinations> in the string 
// 	and delete a 'locate mark' if exist
//
// Entry : 		
//			mark 			= 	String to locate the beginning of changing  
//									or = "" if all 'this' must be scanned.
//			strObjArray		= 	an Array of objects with 
//										object.src  = str to be replaced
//										object.dest = str which replace
// Out ;
//			return the changed string without change the original String
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.str_replace = function(strObjArray, mark) {
	var t = strObjArray;
	var preced = 0;
	var psb = 0;
	var out = new String();
	///////////////////////////////////////////////////////////////////////////////
	if (mark != "" && mark != undefined) {
		while (preced<this.length) {
			var pm = this.indexOf(mark, preced);
			if (pm != -1) {
				// match the mark
				out += this.substring(preced, pm);
				var pme = pm+mark.length;
				var match = false;
				for (var i in t) {
					var pse = pme+t[i].src.length;
					if (t[i].src == this.substring(pme, pse)) {
						// match a string to replace
						out += t[i].dest;
						match = true;
						preced = pse;
						break;
					}
					//if												   
				}
				//for
				if (!match) {
					//out += this.substring(pme,this.length);
					preced = pme;
				}
			} else {
				out += this.substring(preced, this.length);
				break;
			}
		}
		//while
		////////////////////////////////////////////////////////////////////////////////
	} else {
		while (psb<this.length) {
			var match = false;
			for (var i in t) {
				var pse = psb+t[i].src.length;
				if (t[i].src == this.substring(psb, pse)) {
					// match a string to replace
					out += this.substring(preced, psb)+t[i].dest;
					match = true;
					psb = pse;
					preced = pse;
					//trace(out+"/"+pme+"/"+preced+"/"+this.substring(preced)+"/"+pse);
					break;
				}
				//if
			}
			// for				
			if (!match) {
				psb++;
			}
			//if			
		}
		//end while			
		out += this.substring(preced, this.length);
		break;
	}
	// end if mark != ""
	/////////////////////////////////////////////////////////////////////////////////
	return out;
};
// end function
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END of method str_replace ///////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'convertXml' add to class : String of Flash
///////////////////////////////////////////////////////////////////////////////////////////
//   Change some character to 'special substring' in a string (this)
//	 which will be a part of Xml file
//   		Example : '>' '<' and &
//   and return a string result without change the source string (this)
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.convertXml = function() {
	var tt = new Array();
	var o = new Object();
	o.src = "<";
	o.dest = "~#{";
	tt.push(o);
	var o = new Object();
	o.src = ">";
	o.dest = "~#}";
	tt.push(o);
	var o = new Object();
	o.src = "&";
	o.dest = "~#e";
	tt.push(o);
	return this.str_replace(tt, "");
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END of method convertXml ////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'convert_apostr' add to class : String of Flash
///////////////////////////////////////////////////////////////////////////////////////////
//   Change "'" character to char in a string (this)
//   and return a string result without change the source string (this)
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.convert_apostr = function(char) {
	var o = new Object();
	o.src = "'";
	o.dest = char;
	tt= [o] ;
	return this.str_replace(tt, "");
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END of method convertXml ////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
