﻿//////////////////////////////////////////////////////////////////////////
// 					Cfg script class							//
//////////////////////////////////////////////////////////////////////////
function ScriptCfg(winName) {
	this.winName = winName;
}
ScriptCfg.prototype = new SuperScript();

ScriptCfg.prototype.onEndWin = function(letsGo, display, savewin, helpy, voice, noValidate,noUtf8, xMedia) {
	if (letsGo) {
		this.paramAssign(display, savewin, helpy, voice, noValidate,noUtf8, xMedia);		
	}
	//if letsGo = false : we 'll return to language choice
	// else we continue	
	if (letsGo && savewin) {
		if (typeof local.data.cfg == "undefined") {
			local.data.cfg = new Object();
		}
		local.data.cfg.display = display;
		local.data.cfg.saveWin = savewin;
		local.data.cfg.helpy = helpy;
		local.data.cfg.voice = voice;
		local.data.cfg.noValidate = noValidate;
		local.data.cfg.noUtf8 = noUtf8;
		local.data.cfg.xMedia = xMedia ;
	}
	
	this.readHlp() ;	
	this.onEnd(letsGo);
};
ScriptCfg.prototype.paramAssign = function(display, savewin, helpy, voice, noValidate, noUtf8, xMedia ) {
	param.cfgIsSet = true;
	param.cfgDisplay = display;
	param.cfgSaveWin = savewin;
	param.helpy = helpy;
	param.voice = voice;
	param.noValidate = noValidate;
	param.noUtf8 = noUtf8;
	param.xMedia = xMedia ;
};

ScriptCfg.prototype.bufferToScreen = function() {
	// local is equal to SharedObject.getLocal("share"); 	
	if (param.cfgIsSet) {
		var voice = param.voice;
		var helpy = param.helpy;
		var noValidate = param.noValidate;
		var noUtf8 = param.noUtf8;
		var xMedia = param.xMedia ;
		var display = param.cfgDisplay;
		var saveWin = param.cfgSaveWin;
	} else {
		if (typeof local.data.cfg != "undefined") {
			var display = local.data.cfg.display;
			var saveWin = local.data.cfg.saveWin;
			var voice = local.data.cfg.voice;
			var helpy = local.data.cfg.helpy;
			var noValidate = local.data.cfg.noValidate;
			var noUtf8 = local.data.cfg.noUtf8;
			var xMedia = local.data.cfg.xMedia;
		} else {
			var display = true;
			var saveWin = true;
			var helpy = true;			
			var voice = false;
			var xMedia = true ;
			var noValidate = false ;
			var noUtf8 = false ;
		}
		param.helpy = helpy;
		param.voice = voice;
		param.noValidate = noValidate ;
		param.xMedia = xMedia ; 
		param.noUtf8 = noUtf8 ;
	}
	
	this.awin.displayContent(display, savewin, helpy, voice,noValidate, noUtf8, xMedia );
	this.paramAssign(display, savewin, helpy, voice, noValidate, noUtf8, xMedia);
	return display;
};

ScriptCfg.prototype.go = function(uDisplay) {	
	var display = true;
	if (!uDisplay) {
		display = this.bufferToScreen();
	}
	if (display) {		
		this.createWin(c.nivCfg, "cfgWin", CfgWin);
		this.bufferToScreen();
		
		this.onEndReadHlp = function() {
			_global._gHelpOnEnd = _global._gHlpOnEnd ;	
			_gHlpAddEvent(this.aWin,this.aWin._parent) ;
		}
		
		this.readHlp() ;
		
	} else {		
		delete this.onEndReadHlp ;
		this.readHlp() ;
		// if letsGo = false ==> go to precedent window
		var letsGo = true;	
		this.onEnd(letsGo);
	}
		
};

ScriptCfg.prototype.readHlp = function() {
	var language = param.language ;
	
	if (!param.helpy) {
		// deleting _gHelp array
		param.hlpIsSet = false ;
		_gHlpSet(undefined,undefined,param.helpy) ;	
		this.onEndReadHlp() ;
		return ;
	}	
	// if help is already set with the same language => return
	
	if ((param.hlpIsSet) && (param.hlpLang == language) ) {
		
		this.onEndReadHlp() ;
		return ;
	}
	
	// Read mySql's help's labels in xx_help_labels.xml file. 
	fma = new XML();
	scriptCfgInst = this ;
	fma.onLoad = function() {	
			// set general help's onEnd func ;
			// may be changed just before calling help win (_gHelpLoader)
			_gHelpOnEnd = _gHlpOnEnd ;
			// set _gHelp array
			_gHelpSet(this.toObject().help_labels ,this.toObject().help,param.helpy,param.voice) ;
			delete fma;
			
			scriptCfgInst.onEndReadHlp() ;
			delete scriptCfgInst ;
	};
	param.hlpIsSet = true ;
	param.hlpLang = language ;
	var f = language+"_help_labels.xml" ;	
	fma.onGaugeIsStarted = function () {
		fma.load("./help/"+f);
	}
	_gGauge(   fma,   (labels.ggeHelp).toString()   ) ;
};
//////////////////////////////////////////////////////////////////////////
// 					END cfg script class						//
//////////////////////////////////////////////////////////////////////////
