﻿
//////////////////////////////
// field's script class	    //
//////////////////////////////
function ScriptField (listWinName, updWinName, parentInst) {
	this.listWinName = listWinName;
	this.updWinName = updWinName;
	this.parentInst = parentInst ;
}
ScriptField.prototype = new SuperScriptUpd();
// list fields's window 
scriptField.prototype.createListWin = function(niv) {
	this.createWin(niv, "winField", Winfield, c.wfx, c.wfy);
	this.setStateOff();
};

scriptField.prototype.closeWin = function() {
	this.winIsCreate = false;
	this.closeUpdWin();
	this.aListWin.closeWin();
};
scriptField.prototype.setCurrentChoice = function(currentTable) {
	this.currentTable = currentTable;
	this.tableName = this.currentTable.name;
	this.basename = this.parentInst.getCurrentChoice().name;
};
scriptField.prototype.getCurrentChoice = function() {
	return this.currentTable;
};
scriptField.prototype.showElements = function(objTable) {
	// ObjTable is the choosed table object
	this.aListWin.showElements(objTable);
	this.alistWin.doInitScrolling();
	this.aListWin.assignScrolling(this.aListWin.ohead, this.aListWin.olist.ofields);
};

scriptField.prototype.doRollEvent = function(currField) {	
	if (!this.isUpdWinCreate()) {
		this.createUpdWin(c.nivfieldUpd);
		this.setUpdWinState("show", "", 0);
	}
	this.showContent(currField);		
}	
scriptField.prototype.doReleaseEvent = function(currField) {
	this.setElementChoice(currField);
	this.setUpdWinState("update", labels.fieldUpdateTitle+" "+tfield[field.getElementChoice()].field, c.nivFieldUpd);
}	
scriptField.prototype.doOutEvent = function() {		
	if (this.getElementChoice() != undefined && this.getElementChoice() != 0) {
		this.aListWin.assignTitleLabel("off");
		this.showContent(this.getElementChoice());
	} else {
		this.aListWin.assignTitleLabel("on");
		this.closeUpdWin();
	} 
}



ScriptField.prototype.setStateOn = function() {
	this.aListWin.assignTitleLabel("on");
	this.aListWin.putCreateButtonState("on");
	this.aListWin.putDeleteButtonState("on", this);
	this.labelsDeleteConfirm = labels.fieldDeleteConfirm;
	this.classType = "field";
	this.aListWin.assignFunctionsOnEvents(this);
};

ScriptField.prototype.setStateOff = function() {
	this.aListWin.assignTitleLabel("off");
	this.aListWin.putCreateButtonState("off");
	this.aListWin.putDeleteButtonState("off", this);
};
// method executed after the current table's delete by php
ScriptField.prototype.onEndDeleteTable = function(deletedTable) {
	var temp = new Array();
	var j = 0;
	for (var i = 1; i<this.parentInst.getCurrentChoice().table.length; i++) {
		if (this.parentInst.getCurrentChoice().table[i].name != deletedTable) {
			j++;
			temp[j] = this.parentInst.getCurrentChoice().table[i];
		}
	}
	this.parentInst.getCurrentChoice().table = new Array();
	this.parentInst.getCurrentChoice().table = temp;
	delete temp;
	this.parentInst.showElements(this.parentInst.getCurrentChoice());
	this.setCurrentChoice();
	// delete current table's choice in scriptfield  object
	this.closeWin();
	this.parentInst.closeWinButtons();
	this.parentInst.aUpdWin.closeWin();
};
// method to delete the current table
ScriptField.prototype.deleteCurrentElement = function() {
	this.onEndWinDelete = function(valid) {
		if (!valid) {
			this.restoreListWindows();
			this.closeWinDelete();
		} else {
			scriptInstance = this;
			sendphp = new LoadVars();
			sendphp.language = param.language;
			sendphp.className = "table";
			sendphp.action = "delete";
			sendphp.nameToDelete = this.getCurrentChoice().name;
			sendphp.db = this.parentInst.getCurrentChoice().name;
			sendphp.host = server.host;
			sendphp.login = server.login;
			sendphp.pass = server.pass;
			receivephp = new LoadVars();
			receivephp.onLoad = function() {
				if (this.state != "ok") {
					scriptInstance.onEndAlert = function() {
						this.restoreListWindows();
					};
					scriptInstance.showAlert(this.err, labels.allAlertTitle,scriptInstance);
					
				} else {
					scriptInstance.closeWinDelete();
					// Here : table is deleted by the php's prog.					
					scriptInstance.onEndAlert = function() {
						this.restoreListWindows();
						this.onEndDeleteTable(scriptInstance.getCurrentChoice().name);
					};
					scriptInstance.showAlert(labels.tableCreateDeleteOk1+" '"+scriptInstance.getCurrentChoice().name+"' "+labels.allDeleteOk2, "",scriptInstance);
					
				}
			};
			sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
		}
		// end of if (!valid) ... else		
	};
	var underIsVisible = false;
	this.createWinDelete(c.nivDelete, labels.fieldDeleteConfirm, underIsVisible, this.getCurrentChoice().name);
};
//////////////////////////////////////////////
// fields update window attach
//////////////////////////////////////////////
scriptField.prototype.createUpdWin = function(niv) {
	this.createUpdateWin(niv, "winFieldUpd", WinFieldUpd, c.wfux, c.wfuy) ;	
};

scriptField.prototype.getUpdWinState = function() {
	return this.updWinState;
};
// After :   fields's array read from XML/PHP
scriptField.prototype.onEndReadElements = function(temp) {
	tfield = temp.field;
	for (var i in tfield) {
		var typ = tfield[i].type;
		var p = typ.indexOf("(");
		if (p != -1) {
			tfield[i].typeOnly = typ.substring(0, p);
			var pf = typ.indexOf(")");
			tfield[i].len = typ.substring(p+1, pf);
		} else {
			tfield[i].len = "";
			var p = typ.indexOf(" ");
			if (p != -1) {
				tfield[i].typeOnly = typ.substring(0, p);
			} else {
				tfield[i].typeOnly = typ;
			}
		}
	}
	this.setStateOn();
	// show fields in field's window and authorize clic on
};
// Read choosed table's fields from sql server
scriptField.prototype.readElements = function() {
	scriptInstance = this;
	sendphp = new LoadVars();
	sendphp.language = param.language;
	sendphp.className = "field";
	sendphp.action = "getlist";
	sendphp.db = this.parentInst.getCurrentChoice().name;
	sendphp.table = field.getCurrentChoice().name;
	sendphp.host = server.host;
	sendphp.login = server.login;
	sendphp.pass = server.pass;
	receivephp = new XML();
	receivephp.onLoad = function() {
		scriptInstance.onEndReadElements(this.toObject());
	};
	sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
};
// Organize datas before show them
scriptField.prototype.dataOrganize = function(objf) {
	// objf contain the current field 's datas read from mySql
	var datas = new Object();
	datas.name = objf.field;
	var typ = objf.type;
	var p = typ.indexOf("(");
	if (p != -1) {
		datas.typ = typ.substring(0, p);
		var pf = typ.indexOf(")");
		datas.len = typ.substring(p+1, pf);
		datas.attribut = typ.substring(pf+2);
	} else {
		datas.len = "";
		var p = typ.indexOf(" ");
		if (p != -1) {
			datas.typ = typ.substring(0, p);
			datas.attribut = typ.substring(p+1);
		} else {
			datas.typ = typ;
			datas.attribut = "";
		}
	}
	if (datas.attribut == "" || datas.attribut == undefined) {
		datas.attribut = "< "+labels.AllNone+" >";
		datas.attributColor = c.txColorGray;
	} else {
		datas.attributColor = c.txColorLight;
	}
	if (objf.null == "YES") {
		datas.noYesNull = labels.fieldYesNull;
	} else {
		datas.noYesNull = labels.fieldNoNull;
	}
	datas.def = objf.def;
	if (datas.def == "" || datas.def == undefined) {
		datas.def = "< "+labels.AllNone+" >";
		datas.defaultColor = c.txColorGray;
	} else {
		datas.defaultColor = c.txColorLight;
	}
	if (objf.extra == "auto_increment") {
		datas.autoincr = labels.AllYes;
	} else {
		datas.autoincr = labels.AllNo;
	}
	datas.key = objf.key;
	if (datas.key == "" || datas.key == undefined) {
		datas.key = "< "+labels.AllNone2+" >";
		datas.keyColor = c.txColorGray;
	} else {
		datas.keyColor = c.txColorLight;
	}
	if (datas.key == "PRI") {
		datas.key = labels.fieldPri;
	}
	if (datas.key == "MUL") {
		datas.key = labels.fieldMul;
	}
	if (datas.key == "UNI") {
		datas.key = labels.fieldUni;
	}
	return datas;
};
// show one field datas
scriptField.prototype.showContent = function(indxField) {
	this.aUpdWin.showTitle(labels.fieldShowTitle+" "+tfield[indxField].field);
	this.aUpdWin.showContent(this.dataOrganize(tfield[indxField]));
};
// Set the choose's Field
scriptField.prototype.setElementChoice = function(pos) {
	this.currentElem = pos;
};
// Get the choose's Field
scriptField.prototype.getElementChoice = function() {
	return this.currentElem ;
};
// return datas from Input before write to mySql
scriptField.prototype.returnDatasFromInput = function() {
	var datas = new Object();
	datas.name = this.aUpdWin.otx_name.text;
	datas.typ = this.aUpdWin.getComboData(this.aUpdWin.acombotype.ocompo);
	datas.typeOnly = datas.typ;
	datas.after = this.aUpdWin.getComboData(this.aUpdWin.acomboafter.ocompo);
	datas.len = this.aUpdWin.otx_Length.text;
	datas.attribut = this.aUpdWin.getComboData(this.aUpdWin.acomboattribut.ocompo);
	if (datas.len != "") {
		datas.typ += "("+datas.len+")";
	}
	if (datas.attribut != "") {
		datas.typ += " "+datas.attribut;
	}
	//field's null
	if (this.aUpdWin.getRadioState(this.aUpdWin.anotnull.oyes) == true) {
		datas.noYesNull = "YES";
	} else {
		datas.noYesNull = "";
	}
	//field's auto_increment
	if (this.aUpdWin.getRadioState(this.aUpdWin.aautoincr.oyes) == true) {
		datas.autoincr = "auto_increment";
	} else {
		datas.autoincr = "";
	}
	datas.typeIndx = this.aUpdWin.aradioIndex.typeindx.getValue().toUpperCase() ;
	// field's default
	datas.def = this.aUpdWin.otx_default.text;
	if (datas.def == "< "+labels.AllNone+" >") {
		datas.def = "";
	}
	return datas;
};
// Update Array buffer 'Tfield' after write to mySql
scriptField.prototype.screenToBuffer = function(datas) {
	tfield[this.getElementChoice()].field = datas.name;
	tfield[this.getElementChoice()].type = datas.typ;
	tfield[this.getElementChoice()].null = datas.noYesNull;
	tfield[this.getElementChoice()].extra = datas.autoincr;
	tfield[this.getElementChoice()].def = datas.def;
	tfield[this.getElementChoice()].len = datas.len;
	tfield[this.getElementChoice()].typeOnly = datas.typeOnly;
};
// field write to mySql end event
scriptField.prototype.onEndUpdatedElement = function(datas) {
	this.screenToBuffer(datas);
	this.setUpdWinState("show", "", 0);
	this.setMustReadDatas("datasUpd");
};
// Write to sql base, the current updated field 
scriptField.prototype.writeUpdatedElement = function() {
	this.aupdWin.disableEventsAndGray();
	this.alistwin.restoreEventLabel(labels.fieldCreate);
	var temp = this.returnDatasFromInput();
	scriptInstance = this;
	this.newSendPhp();
	sendphp.req = "ALTER TABLE "+sendphp.db+"."+field.getCurrentChoice().name+"";
	sendphp.req += " CHANGE "+temp.name+" "+temp.name+" ";
	sendphp.req += temp.typ;
	if (temp.def != "" || temp.noYesNull == "YES") {
		sendphp.req += " DEFAULT ";
		if (temp.def != "") {
			sendphp.req += " '"+temp.def.convert_apostr("''")+"' ";
		}
	}
	if (temp.def == "" || temp.noYesNull != "YES") {
		if (temp.noYesNull != "YES") {
			sendphp.req += " NOT NULL";
		} else {
			sendphp.req += " NULL";
		}
	}
	if (temp.autoincr == "auto_increment") {
		sendphp.req += " AUTO_INCREMENT";
	}
	sendphp.req += ";";
	receivephp = new LoadVars();
	receivephp.onLoad = function() {
		if (this.state != "ok") {		
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();
			};
			scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);
		} else {
			// Here : sql's base is updated by php			
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();
				this.onEndUpdatedElement(temp);
			};
			scriptInstance.showAlert(labels.fieldUpdateTitle+" '"+temp.name+"' "+labels.allOk, "",scriptInstance);

		}
	};
	sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
};
// verify datas input
scriptField.prototype.checkInput = function(temp) {
	var err = "";
	if (temp.name == "") {
		err = labels.fieldNameMissing;
	}
	if (temp.typ.substring(0, 7) == "VARCHAR" && temp.typ.substring(7, 8) != "(") {
		err = labels.fieldLenMissing;
	}
	for (var i in this.getCurrentChoice().field) {
		if (temp.name == this.getCurrentChoice().field[i].name) {
			err = labels.fieldAlreadyExist;
			break;
		}
	}
	if (err != "") {
		//ici 050514		
		this.aUpdWin.showAlert(err,labels.allAlertTitle,undefined,this.aUpdWin);
		//this.aUpdWin.aalertwin.olabel_title.text = labels.allAlertTitle;
		this.aUpdWin.setScriptInst(this);
		this.aUpdWin.onEndAlert = function() {
			this.restoreEvents() ;
		};
		return false;
	} else {

		return true;
	}
};
scriptField.prototype.insertToArrayBuffer = function(after, datas) {
	indx = Infinity;
	if (after == "FIRST") {
		indx = 1;
	}
	if (after == "") {
		indx = tfield.length;
	}
	if (indx == Infinity) {
		for (var i = 1; i<=tfield.length; i++) {
			if (tfield[i].field == after) {
				var indx = i+1;
				break;
			}
		}
	}
	if (indx == Infinity) {
		return false;
	}
	var obj = new Object();
	obj.field = datas.name;
	var obj2 = new Object();
	obj2.name = datas.name;
	if (indx == tfield.length) {
		tfield.push(obj);
		this.getCurrentChoice().field.push(obj2);
	} else {
		tfield.splice(indx, 0, obj);
		this.getCurrentChoice().field.splice(indx, 0, obj2);
	}
	delete obj;
	delete obj2;
	return indx;
};
// field insert to mySql end event
scriptField.prototype.onEndCreatedElement = function(datas) {
	var after = datas.after;
	if ((after != "FIRST") && (after != "")) {
		after = datas.after.substring(6, datas.after.length);
	}
	var indx = this.insertToArrayBuffer(after, datas);
	this.setElementChoice(indx);
	this.screenToBuffer(datas);
	this.showElements(this.getCurrentChoice());
	this.setUpdWinState("show", "", 0);
	this.setMustReadDatas("datasUpd");	
	 if (this.get_andInsert()) {
		this.alistWin.onEnterFrame = function () {
			this.ocreate.onRelease();
			delete this.onEnterFrame ;
		}
	}
		
};

// Write to mySql base, the created field 
scriptField.prototype.writeCreatedElement = function() {
	var temp = this.returnDatasFromInput();
	this.updWin.disableEventsAndGray();
	this.alistwin.restoreEventLabel(labels.fieldCreate);
	if (!this.checkInput(temp)) {
		return;
	}
	scriptInstance = this;
	this.newSendPhp();
	sendphp.req = "ALTER TABLE "+sendphp.db+"."+field.getCurrentChoice().name+"";
	sendphp.req += " ADD "+temp.name+" ";
	//
	sendphp.req += temp.typ;
	if (temp.def != "" || temp.noYesNull == "YES") {
		sendphp.req += " DEFAULT ";
		if (temp.def != "") {
			sendphp.req += " '"+temp.def+"' ";
		}
	}
	if (temp.def == "" || temp.noYesNull != "YES") {
		if (temp.noYesNull != "YES") {
			sendphp.req += " NOT NULL";
		} else {
			sendphp.req += " NULL";
		}
	}
	if (temp.autoincr == "auto_increment") {
		sendphp.req += " AUTO_INCREMENT";
	}
	sendphp.req += " "+temp.after;
	//
	sendphp.req += ";";
	//
	receivephp = new LoadVars();
	receivephp.onLoad = function() {
		if (this.state != "ok") {
			scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();
			};
		} else {
			// Here : sql's base is updated by php	
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();
				this.onEndCreatedElement(temp);
			};			
			scriptInstance.showAlert(labels.fieldUpdateTitle+" '"+temp.name+"' "+labels.allOk, "",scriptInstance);

		}
	};
	sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
};
// field delete end event
scriptField.prototype.onEndDeleteElement = function(deletedElement) {
	this.getCurrentChoice().dIndex = undefined;
	// Init index  buffer
	var temp = new Array();
	var j = 0;
	for (var i = 1; i<tfield.length; i++) {
		if (tfield[i].field != deletedElement) {
			j++;
			temp[j] = tfield[i];
		}
	}
	tfield = new Array();
	tfield = temp;
	var temp = new Array();
	var j = 0;
	for (var i = 1; i<this.getCurrentChoice().field.length; i++) {
		if (this.getCurrentChoice().field[i].name != deletedElement) {
			j++;
			temp[j] = this.getCurrentChoice().field[i];
		}
	}
	this.getCurrentChoice().field = new Array();
	this.getCurrentChoice().field = temp;
	delete temp;
	this.showElements(this.getCurrentChoice());
	this.setStateOn();
	this.setElementChoice();
	// delete current element's choice 
	this.closeUpdWin();
	this.setMustReadDatas("datasUpd");
};
scriptField.prototype.cancel = function(isCreation) {
	this.alistwin.restoreEventLabel(labels.fieldCreate);
	this.setUpdWinState("show", "", 0);
	if (isCreation && (this.getElementChoice() == 0 || this.getElementChoice() == undefined)) {
		//thiswin.getScriptInst().closeUpdWin();
		this.closeUpdWin();
	}
};
// Delete from MySql base, the current  field 
scriptField.prototype.deleteElement = function() {
	this.onEndWinDelete = function(valid) {
		if (!valid) {
			this.aUpdWin.restoreEvents();
			this.closeWinDelete();
			
		} else {
			scriptInstance = this;
			this.newSendPhp();
			sendphp.req = "ALTER TABLE "+field.getCurrentChoice().name;
			var nameField = tfield[this.getElementChoice()].field;
			sendphp.req += " DROP "+nameField;
			receivephp = new LoadVars();
			receivephp.onLoad = function() {
				if (this.state != "ok") {
					scriptInstance.onEndAlert = function() {
						this.aUpdWin.restoreEvents();
					};
					scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);
					
				} else {
					scriptInstance.closeWinDelete();
					// Here : sql's base is updated by php		
					scriptInstance.onEndAlert = function() {
						this.aUpdWin.restoreEvents();
						this.restoreListWindows();
						// restore events for list windows
						this.onEndDeleteElement(nameField);
					};
					scriptInstance.showAlert(labels.fieldCreateDeleteOk1+" '"+nameField+"' "+labels.allDeleteOk1, "",scriptInstance);
					
				}
			};
			sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
		}
		// end of : if (!valid) {		
	};
	// end of : this.onEndWinDelete 
	this.aUpdWin.disableEventsAndGray();
	this.createWinDelete(c.nivDelete, labels.fieldElemDeleteConfirm, underIsVisible, tfield[this.getElementChoice()].field);
};