﻿
//////////////////////////////////////////////////////////////////////////
// 					Import or Sql request exec script class			    //
//////////////////////////////////////////////////////////////////////////
function ScriptSql(updWinName, aButtonWin) {
	this.updWinName = updWinName;
	this.aButtonWin = aButtonWin;
	
}
ScriptSql.prototype = new SuperScriptUpd();
ScriptSql.prototype.go = function(tfieldArray, currentTableArray, basename) {
	this.assignMainObjectAndArray(tfieldArray, currentTableArray, basename);
	// Create Sql's window 
	this.createUpdateWin(c.nivSql, "sqlwin", sqlwin, c.wsx, c.wsy);
	this.aUpdWin.assignFunctionsOnEvents();
};
// Cancel 
scriptSql.prototype.cancel = function() {
	this.ReturnToDescription();
	this.aButtonWin.restoreEvents();
};
scriptSql.prototype.getReq = function() {
	return this.Req;
};
scriptSql.prototype.setReq = function(req) {
	// req come from sqlwin
	this.Req = Req;
};
scriptSql.prototype.getAns = function() {
	return this.ans;
};
scriptSql.prototype.setAns = function(ans) {
	// ans come from php/mysql
	this.ans = ans;
};
scriptSql.prototype.onEnd = function(valid,cancel) {
	scriptSqlInstance = this;
	server.onEndGetBases = function(err, tbases) {
		if (err != "") {
			this.alertMessage(err, this.awindow);
			delete onEndGetBases;
		} else {
			scriptSqlInstance.isDone = true;
			tbase = new Array();
			tbase = tbases;
			if (valid) {
				scriptSqlInstance.isDone = false;
				field.closewin();
				table.closewin();
				base.closewin();
				delete field;
				delete table;
				delete base;
				base = new ScriptBase();
				base.createWinBase(c.nivBase);
				scriptSqlInstance.cancel();
			} else {
				scriptSqlInstance.restoreListWindows();
				awinbase.showElements();
				awinbase.assignScrolling(awinbase.ohead, awinbase.olist.obases);
				table.showElements(table.getCurrentChoice());
				field.showElements(field.getCurrentChoice());
				scriptSqlInstance.disableListWindows();
				if (cancel) scriptSqlInstance.cancel();
			}
			export.clearBuffers();
			delete scriptSqlInstance;
			delete onEndGetBases;
		}
	};
	server.getListBases();
};


scriptSql.prototype.execRequest = function(valid, cancel) {
	// valid is true only if : (clic on valid)  
	// valid=true means that the window will be closed
	// valid= false means apply and continue without close window	
	// cancel is true only if : clic on cancel after apply(s)
	this.aUpdWin.disable();
	this.aButtonWin.oSql.disableOne();
	if (cancel) {
		this.onEnd(valid,cancel);
		return;
	}
	if (this instanceof scriptSelSql) {
		this.selSqlOn = true;
	} else {
		this.selSqlOn = false;
	}
	if (this.selSqlOn) {
		var msgerr = "";
		var sql = this.getReq().toUpperCase();
		if ((sql.indexOf("DROP") != -1) || (sql.indexOf("CREATE") != -1) || (sql.indexOf("ALTER") != -1)) {
			msgerr = labels.sqlSelectInvalid;
		}
		if (msgerr.isSetAndNotNull()) {
			this.aupdwin.onEndAlert = function() {
				this.restoreEvents();
			};
			this.aupdwin.showAlert(msgerr,labels.allAlertTitle,false,this.aupdwin);
			return;
		} else {
			sql = this.getReq();
			this.goToExec(sql,valid) ;
		}
	} else {
		sql = this.getReq();
		
		//
		if ( (sql.indexOf("CREATE") != -1) && (sql.indexOf("`") != -1) )  {
			this.onEndAlert = function (button) {
				if (button.toLowerCase() == "ocancel") {
					this.aUpdWin.restoreEvents();
				} else {
					this.goToExec(sql,valid) ;
				}
			}
			var yesNo = true ; // Yes/No type alert
			this.showAlert(labels.sqlBackQuote,labels.allAlertTitle,this,yesNo);
														   
		} else {
			this.goToExec(sql,valid) ;
		}
		
		//
	}
	
};
Script.prototype.convertSemiColon = function(sql) {
	var vCur=0;
	var vOpen=false;
	var vArr=new Array();
	while(vCur<sql.length) {
		pos = sql.indexOf("'", vCur);
		
		if (pos > -1) {
			vOpen=!vOpen ;
			if (vOpen) {
				var o = new Object();
				o.firstC = pos ;
			} else {
				o.lastC = pos ;
				vArr.push(o);
			}
			vCur=pos+1;
		} else {
			vCur=sql.length;
		}
	}
	var vOut = sql ;
	if (vArr.length>0) {
		 vOut = sql.substring(0,vArr[0].firstC);
		for (var i=0;i<vArr.length;i++) {			
			var vSub=sql.substring(vArr[i].firstC,vArr[i].lastC).str_replace([{ src:";",dest:"~#sc" }]);
			var vRestBegin=vArr[i].lastC;
			if ( i+1<vArr.length) vRestEnd=vArr[i+1].firstC ;
			else vRestEnd=sql.length;			
			vOut+=vSub+sql.substring(vRestBegin,vRestEnd) ;
		}
	}
	return vOut ;
}
scriptSql.prototype.goToExec = function(sql,valid) {
		// convertion
    	sql = sql.str_replace([{ src:"'",dest:"''" }],"\\");
		sql = this.convertSemiColon(sql);
		var scriptInstance = this;
		this.newSendPhp();
		sendphp.req = sql;
		sendphp.action = "xrequest";
		receivephp = new LoadVars();
		receivephp.onLoad = function() {
			//_gAlert("this.err="+this.err);
			if (this.state != "ok") {
				if (!this.err.isSetAndNotNull()) this.err = labels.allFatalError ;
				scriptInstance.onEndAlert = function() {
					this.aUpdWin.restoreEvents();
				};
				scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);				
			} else {
				var res = this.res.str_replace([{ src:"#{",dest:"&gt;" },{ src:"#}",dest:"&lt;" },{ src:"#\"",dest:"&quot;" },{ src:"#e",dest:"&amp;" }],"~");
				scriptinstance.setAns(res);
				scriptInstance.onEndAlert = function() {
					this.aUpdWin.restoreEvents();
					this.onEnd(valid);
				};
				scriptInstance.showAlert(labels.sqlRequestIsDone, "",scriptInstance);
				export.clearBuffers();
			}
		};		
		receivephp.onGaugeIsStarted = function () {
			sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
		}
		_gGauge(receivephp,labels.ggeSql) ;
};
